<?php
/**
 * 連載記事ユニット縦3列.
 *
 * @package extunits\extVCatList4
 *
 * @copyright 2008-2017 Shift Tech Inc. All Rights Reserved.
 * @author    シフトテック株式会社<http://www.shift-tech.jp>
 *
 * @version 1.0
 */
require_once(LIB_PATH.'/common/unitCommon.php');
require_once(LIB_PATH.'/common/pageView.php');

class extVCatList4 extends unitCommon
{
    //------ ユニット毎に必ず設定しなくてはならない変数 -------//
    public $_table = "extunit_extvcatlist4"; //公開用テーブル名
    public $_tmptable = "extunit_extvcatlist4_tmp"; //下書き用テーブル名 //必ず公開用テーブル名のうしろに_tmpをつけてください
    public $columns = array(
        array("column"=>"pageu_code","conv"=>"n","tags"=>false),        //ユニット登録コード
        array("column"=>"catlist_sidx_code","conv"=>"","tags"=>false),    //セクションIDXコード
        array("column"=>"catlist_cat_code","conv"=>"","tags"=>false),    //カテゴリーコードの文字列「:」で区切って保存
        array("column"=>"catlist_label_code","conv"=>"","tags"=>false),    //ラベルコードの文字列「:」で区切って保存
        array("column" => "catlist_label_view", "conv" => "n", "tags" => false),  //ラベル表示フラグ
        array("column" => "catlist_label_color", "conv" => "n", "tags" => false),  //ラベル色表示フラグ
        array("column"=>"catlist_s_count","conv"=>"","tags"=>false),    //表示開始件数
        array("column"=>"catlist_limit","conv"=>"","tags"=>false),        //表示情報件数設定
        array("column"=>"catlist_pflg","conv"=>"","tags"=>false),        //ページングの有無 0：なし　1：あり
        array("column"=>"catlist_date_flg","conv"=>"","tags"=>false),    //公開日表示 0：なし　1：あり
        array('column'=>'catlist_date_format', 'conv' => '', 'tags' => false),  //公開日の日付書式
        array("column"=>"catlist_rss","conv"=>"","tags"=>false),        //RSS 0：なし　1：あり
        array("column"=>"catlist_new_flg","conv"=>"","tags"=>false),    //NEWアイコン表示 0：なし　1：あり
        array("column"=>"catlist_comment_flg","conv"=>"","tags"=>false),//一覧コメント 0：なし　1：あり
        array("column"=>"catlist_new_days","conv"=>"","tags"=>false),    //NEWアイコン表示期間
        array("column"=>"catlist_order","conv"=>"","tags"=>false),        //表示順　1：公開日の昇順　2：公開日の降順
        array('column' => 'catlist_sp_layout', 'conv' => 'n', 'tags' => false),    //スマホレイアウト（フリック）1：使う
        array('column' => 'bg_color', 'conv' => '', 'tags' => false),      //背景色
        array('column' => 'bdr_type', 'conv' => '', 'tags' => false),      //囲み線
        array('column' => 'btm_padding', 'conv' => '', 'tags' => false),    //下部余白
        array('column' => 'bg_color_sp', 'conv' => 'n', 'tags' => false),    //背景色
        array('column' => 'bdr_type_sp', 'conv' => 'n', 'tags' => false),    //枠線
        array('column' => 'btm_padding_sp', 'conv' => 'n', 'tags' => false),    //下方スペース
        array('column' => 'use_pc_flg', 'conv' => 'n', 'tags' => false),    //PC表示 v1.6
        array('column' => 'use_sp_flg', 'conv' => 'n', 'tags' => false),      //スマホ表示
        array('column' => 'extra_class', 'conv' => 'as', 'tags' => false),  //追加クラス
        array('column' => 'option_extend', 'conv' => 'n', 'tags' => false),  //デザインオプションの継承
    );


    //ユニットデータ
    public $_data = array();
    //ページデータ
    public $_page_data = array();

    public function __construct()
    {
        unitCommon::__construct();
    }

    //出力データセット処理（必須）
    public function setDisplayData()
    {
        $this->_data = $this->getDetail();
        //データがない場合はNULLを返す
        if (count($this->_data) == 0) {
            return;
        }

        /* v1.3 2009.07.14 完全動的にもどす*/
        $rtn = $this->setList($this->_data);
        //リストデータ
        $this->_data['list'] = $rtn['pagedata'];
        //ページング
        $this->_data['Pages'] = $rtn['Pages'];
        //選択されたカテゴリ名
        $this->_data['category'] = $rtn['category'];

        //RSSを表示するためのリンク作成
        $d = $this->getRequest('d');
        $c = '';
        $cat = explode(':', $this->_data['catlist_cat_code']);
        foreach ($cat as $val) {
            $c .= '&c[]='.$val;
        }
        $l = '';
        $lebel = explode(':', $this->_data['catlist_label_code']);
        foreach ($lebel as $val) {
            $l .= '&l[]='.$val;
        }
        $_tmp = ($this->_prev) ? '&prev=1' : '';

        //日付書式
        $this->_data['date_format'] = isset($this->date_format[ $this->_data['catlist_date_format'] ]) ? $this->date_format[ $this->_data['catlist_date_format'] ]['format'] : _gettext('B_T00819');

        //表示開始件数
        $catlist_s_count = (isset($this->_data['catlist_s_count'])) ? $this->_data['catlist_s_count'] : 0;
        $offset = $catlist_limit + ($catlist_s_count - 1);
        $this->_data['rss'] = '/rss.php?'.$c.$l.'&d='.$d.'&s='.$this->_data['catlist_sidx_code'].'&o='.$this->_data['catlist_order'].'&offset='.$offset.$_tmp;
        $this->_view->assign('sptpl', dirname(__FILE__).'/extVCatList4-sp.tpl');
        if (count($this->_data) > 0) {
            return $this->_data;
        } else {
            return;
        }
    }

    /*
     * DBより保存データ取得
     * 改変可能
     */
    public function getDetail()
    {
        $rtn =  null;
        $sql = "select * from ".$this->getTbl()." where pageu_code = ?";
        if (isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
            $result = $this->db->prepare($sql, $this->_pageu_code);
            if ($result!=null) {
                $rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);
            }
        }
        return $rtn;
    }


    public function setDefault()
    {
        $data = $this->getDetail();
        if (count($data) == 0) {
            $this->_form->setDefaults(
                array('catlist_limit' => 20,
                      'catlist_date_flg' => 1,
                      'catlist_comment_flg' => 1,
                      'catlist_rss' => 1,
                      'catlist_new_flg' => 1,
                      'catlist_order' => 2, )
            );
        }
        if ($this->getRequest('ocg') == '') {
            //カテゴリの初期値設定
            if (isset($data['catlist_cat_code'])) {
                $tmp = explode(':', $data['catlist_cat_code']);
                $data['catlist_cat_code'] = array();
                foreach ($tmp as $val) {
                    if ($data['catlist_sidx_code'] == $val) {
                        $data['catlist_cat_code'][0] = $val;
                    } else {
                        $data['catlist_cat_code'][$val] = $val;
                    }
                }
            }

            //ラベルの初期値設定
            if (isset($data['catlist_label_code'])) {
                $tmp = explode(':', $data['catlist_label_code']);
                $data['catlist_label_code'] = array();
                foreach ($tmp as $val) {
                    $data['catlist_label_code'][$val] = $val;
                }
            }

            if (isset($data['catlist_sidx_code']) && !empty($data['catlist_sidx_code'])) {
                $this->setCategoryObj($data['catlist_sidx_code'], $data['catlist_cat_code']);
            }
            if (isset($data['catlist_sidx_code']) && is_numeric($data['catlist_sidx_code'])) {
                $this->setLabelObj($data['catlist_sidx_code']);
            }
        }
        $this->_form->setDefaults($data);
    }
    /**
     * フォームエレメントの作成.
     */
    public function setElements()
    {
        $this->_form->addElement('hidden', 'pageu_code', $this->_pageu_code, array('id' => 'pageu_code')); //ページコード
        //onChangeチェック用
        $this->_form->addElement('hidden', 'ocg', '1', array('id' => 'ocg'));
        //カテゴリ選択
        $data = array('' => _gettext('B_P00567'), '0' => _gettext('B_P00889')) + $this->getSectionData();
        $this->_form->addElement('select', 'catlist_sidx_code', null, $data, array('onChange' => 'reload();'));
        if ($this->getRequest('catlist_sidx_code') != '' && $this->getRequest('catlist_sidx_code') != 0) {
            $this->setCategoryObj($this->getRequest('catlist_sidx_code'));
        }
        //ラベル選択
        $catlist_sidx_code = isset($_POST['catlist_sidx_code']) ? $_POST['catlist_sidx_code'] : null;
        if ($catlist_sidx_code !== '' && $catlist_sidx_code !== null) {
            $this->setLabelObj($catlist_sidx_code);
        }
        //ラベル表示
        $this->_form->addElement('advcheckbox', 'catlist_label_view', null, _gettext('B_P01059'), array('id' => 'catlist_label_view'), array(0, 1));
        $this->_form->addElement('advcheckbox', 'catlist_label_color', null, _gettext('B_P01070'), array('id' => 'catlist_label_color'), array(0, 1));
        //表示開始
        $data = array('1' => '1', '2' => '2', '3' => '3', '4' => '4', '5' => '5', '6' => '6', '7' => '7', '8' => '8', '9' => '9', '10' => '10');
        $this->_form->addElement('select', 'catlist_s_count', null, $data, array('id' => 'catlist_s_count'));
        //表示件数
        // $data = array('1' => '1', '2' => '2', '3' => '3', '4' => '4', '5' => '5', '6' => '6', '7' => '7', '8' => '8', '9' => '9', '10' => '10', '20' => '20', '30' => '30', '40' => '40', '50' => '50');
        // $this->_form->addElement('select', 'catlist_limit', null, $data, array('id' => 'catlist_limit'));
        $this->_form->addElement('text', 'catlist_limit', null, array('id' => 'catlist_limit', 'class' => 'num numL', 'maxlength' => '3'));
        //ページングの有無
        $this->_form->addElement('advcheckbox', 'catlist_pflg', null, _gettext('B_P00533'), array('id' => 'catlist_pflg'), array(0, 1));
        //公開日表示
        $this->_form->addElement('advcheckbox', 'catlist_date_flg', null, _gettext('B_P00533'), array('id' => 'catlist_date_flg'), array(0, 1));
        //RSS
        $this->_form->addElement('advcheckbox', 'catlist_rss', null, _gettext('B_P00533'), array('id' => 'catlist_rss'), array(0, 1));
        //NEWアイコン
        $this->_form->addElement('advcheckbox', 'catlist_new_flg', null, _gettext('B_P00533'), array('id' => 'catlist_new_flg'), array(0, 1));
        //NEWアイコン表示期間
        $this->_form->addElement('text', 'catlist_new_days', null, array('size' => '5', 'id' => 'catlist_new_days', 'value' => 7, 'style' => 'ime-mode:disabled'));
        //一覧コメント
        $this->_form->addElement('advcheckbox', 'catlist_comment_flg', null, _gettext('B_P00533'), array('id' => 'catlist_comment_flg'), array(0, 1));
        //表示順
        $item = array();
        $item[] = $this->_form->createElement('radio', null, null, _gettext('B_P00890'), 1);
        $item[] = $this->_form->createElement('radio', null, null, _gettext('B_P00891'), 2);
        $this->_form->addGroup($item, 'catlist_order');
        $this->_form->getElement('catlist_order');
        $this->_form->addElement('advcheckbox', 'catlist_sp_layout', null, _gettext('B_P00916'), array(), array(0, 1));

        //日付の表示形式
        $item = array();
        foreach ($this->date_format as $k => $v) {
            $item[$k] = $v['disp'];
        }
        $this->_form->addElement('select', 'catlist_date_format', null, $item);
    }
    /**
     * フォーム入力エラーチェックの設定.
     */
    public function setRules()
    {
        $this->_form->applyFilter('__ALL__', 'trim');
        $this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues, $this->columns); //ルールに従った値変換、タグの除去
        $this->_form->setJsWarnings(_gettext('B_P00472'), '');
        $this->_form->registerRule('NumericRange', 'callback', 'NumericRange');
        $this->_form->addRule('pageu_code', _gettext('B_P00643'), 'required', null, $this->erchk);
        $this->_form->addRule('catlist_sidx_code', _gettext('B_P00882'), 'required', null, $this->erchk);
        $this->_form->addRule('catlist_s_count', _gettext('B_P00883'), 'required', null, $this->erchk);
        $this->_form->addRule('catlist_limit', _gettext('B_P00884'), 'required', null, $this->erchk);
        $this->_form->addRule('catlist_limit', _gettext('B_P01105', array(_gettext('B_T00814'), 1, 100)), 'NumericRange', array(1, 100), $this->erchk);
        $this->_form->addRule('catlist_new_days', _gettext('B_P00893'), 'numeric', null, $this->erchk);
        $this->_form->addRule('catlist_order', _gettext('B_P00885'), 'required', null, $this->erchk);
        $catlist_cat_code = $this->getRequest('catlist_cat_code');
        $catlist_label_code = $this->getRequest('catlist_label_code');

        if ($this->getRequest('buttons') != '') {
            if (is_numeric($this->getRequest('catlist_sidx_code'))) {
                if ($this->getRequest('catlist_sidx_code') == 0) {
                    if (!is_array($catlist_label_code)) {
                    }
                } else {
                    if (!is_array($catlist_cat_code)) {
                        $this->_form->setElementError('catlist_cat_code', _gettext('B_P00878'));
                    }
                }
            }
        }

        $catlist_new_flg = $this->getRequest('catlist_new_flg');
        if ($catlist_new_flg != '0' && $this->getRequest('buttons') != '') {
            $this->_form->addRule('catlist_new_days', _gettext('B_P00877'), 'required', null, $this->erchk);
        }
    }

    //データ下書き保存処理
    public function doSave($post)
    {
        $record = null;
        foreach ($this->columns as $val) {
            if ($post[$val["column"]]!=null) {
                $record[$val["column"]] = $post[$val["column"]];
            } else {
                $record[$val["column"]] = null;
            }
        }
        //カテゴリは:区切りで保存
        if (is_array($this->getRequest('catlist_cat_code'))) {
            $data = $this->getRequest('catlist_cat_code');
            $str = array();
            foreach ($data as $k=>$v) {
                if ($k==0) {
                    $str[] =$record["catlist_sidx_code"];
                } else {
                    $str[] = $k;
                }
            }
            $record['catlist_cat_code'] = join(':', $str);
        }

        //ラベルは:区切りで保存
        if (is_array($this->getRequest('catlist_label_code'))) {
            $data = $this->getRequest('catlist_label_code');
            $str = array();
            foreach ($data as $k=>$v) {
                if ($k==0) {
                    $str[] =$record["catlist_label_code"];
                } else {
                    $str[] = $k;
                }
            }
            $record['catlist_label_code'] = join(':', $str);
        }
        //既存データがあるか確認
        $old_data = $this->getDetail();
        $this->db->query('BEGIN');
        //保存処理開始
        if (is_array($old_data)&& count($old_data)>0) {
            //更新
            if (!$this->db->update($this->getTbl(), $record, "pageu_code=".$record["pageu_code"])) {
                $this->db->query('ROLLBACK');
                return _gettext('B_P00209');
            }
        } else { //新規
            if (!$this->db->insert($this->getTbl(), $record)) {
                $this->db->query('ROLLBACK');
                return _gettext('B_P00209');
            }
        }
        $this->db->query('COMMIT');
        return null;
    }

    public function getSectionData()
    {
        $_tmp = ($this->_prev) ? '_tmp' : '';
        //v1.2 連載型モジュールで生成したメニューからのみ選択可能とする。
        /*
        $sql = "select sidx_code,sidx_title,sidx_order from tbl_section_idx{$_tmp}
                    where sidx_active=1 and sidx_extmodule_code = {$this->_unit_data["unit_extmodule_code"]}
                    order by sidx_order";*/
        $sql = "select sidx_code,sidx_title,sidx_order from tbl_section_idx{$_tmp}
					where sidx_active=1 AND sidx_parent_sidx_code=0 AND (sidx_extmodule_code IS NULL OR NOT(sidx_extmodule_code >=1000 AND sidx_extmodule_code < 2000)) order by sidx_order";
        $return = $this->db->query($sql);
        if (DB::IsError($return)) {
            die();
        }
        $data = array();
        while ($row = $return->fetchRow(DB_FETCHMODE_ASSOC)) {
            $data[$row['sidx_code']] = $row['sidx_title'];
        }
        return $data;
    }

    /**
    * セクションIDXコードからカテゴリをQFにセットする
    *
    * @author Nobuo Nishino
    * @param integer $catlist_sidx_code セクションIDXコード
    * @param array $default カテゴリコードの配列
    */
    public function setCategoryObj($catlist_sidx_code=null, $default=array())
    {
        $_tmp = ($this->_prev) ? '_tmp' : '';
        $checks = array();
        //v1.2
        $sql = "select sidx_code, sidx_title, sidx_order from tbl_section_idx{$_tmp}
		where sidx_active = 1 and (sidx_parent_sidx_code = {$catlist_sidx_code})
		order by sidx_order ";
        $return = $this->db->query($sql);
        if (DB::IsError($return)) {
            die();
        }
        $checks[] =& $this->_form->createElement('checkbox', "0", null, _gettext('B_P00886'));
        while ($row = $return->fetchRow(DB_FETCHMODE_ASSOC)) {
            $checks[] =& $this->_form->createElement('checkbox', $row['sidx_code'], null, $row['sidx_title']);
        }
        $this->_form->addGroup($checks, 'catlist_cat_code', null, "<br />\n");
        //		if ($catlist_sidx_code != null) {
//			$_tmp = ($this->_prev) ? '_tmp' : '';
//			$checks = array();
//			//v1.2
//			$sql = "select cat_code, cat_name, cat_order from tbl_category{$_tmp}
//			where cat_active = 1 and (cat_sidx_code = {$catlist_sidx_code} or cat_code = 1)
//			order by cat_order ";
//			$return = $this->db->query($sql);
//			if (DB::IsError($return)) {
//				die();
//			}
//			while($row = $return->fetchRow(DB_FETCHMODE_ASSOC)) {
//				$checks[] =& $this->_form->createElement('checkbox', $row['cat_code'], null, $row['cat_name']);
//			}
//			$this->_form->addGroup($checks, 'catlist_cat_code', null, "<br />\n");
//		}
    }

    public function setLabelObj($catlist_sidx_code=null)
    {
        //SaaS
        $data=$this->getDetail();
        $catlist_sidx_code = is_null($catlist_sidx_code)? $data["catlist_sidx_code"]:$catlist_sidx_code;
        if ($catlist_sidx_code==0) {
            $catlist_sidx_code="";
        }
        $checks = array();
        $_param=array();
        $_bind=array();
        $labels=null;
        $sql = "SELECT * FROM tbl_label WHERE label_active=1 and label_admin_type=0 ";// label_admin_type を追加 2010.06.03 sugi
        if (is_numeric($catlist_sidx_code)) {
            //メニュー・ローカルのページ一覧取得
            $_sql="SELECT
				pidx_code,
				pidx_sidx_code,
				pidx_cat_code,
				pidx_extmodule_code,
				pidx_title,
				pidx_label
				FROM tbl_section_idx_tmp as s
				JOIN tbl_page_idx_tmp as p
				ON s.sidx_code=p.pidx_sidx_code
				AND p.pidx_ptype=1 AND p.pidx_active=1
				WHERE sidx_code=? OR sidx_parent_sidx_code=?";
            $result=$this->db->prepare($_sql, array($catlist_sidx_code,$catlist_sidx_code));
            if ($result) {
                $labels=array();
                while ($row=$result->fetchRow(DB_FETCHMODE_ASSOC)) {
                    if (!empty($row["pidx_label"])) {
                        $labels=array_unique(array_merge($labels, explode("<>", $row["pidx_label"])));
                    }
                }
            }

            if (!empty($labels)&&is_array($labels)) {
                foreach ($labels as $k=>$v) {
                    $_bind[]="?";
                    $_param[]=$v;
                }
                $sql .=" AND label_code IN(".implode(",", $_bind).")";
            } else {
                $sql .=" AND 1=0";
            }
        }
        $return = $this->db->prepare($sql, $_param);
        if (DB::IsError($return)) {
            die();
        }
        while ($row = $return->fetchRow(DB_FETCHMODE_ASSOC)) {
            $checks[] =& $this->_form->createElement('checkbox', $row['label_code'], null, $row['label_name']);
        }
        $this->_form->addGroup($checks, 'catlist_label_code', null, "<br />\n");
    }

    /**
    * 選択されているカテゴリからパラメータに合わせて一覧を表示する
    *
    * @author Nobuo Nishino
    * @param array $data データの配列
    */
    public function setList($data)
    {
        //リクエストページ番号
        if ($this->_pageu_code == $this->getRequest('pageu_code')) { //v1.3
            $idx = $this->getRequest('idx');
        }
        if (!is_numeric($idx) || $idx < 1) {
            $idx = 1;
        }
        $rtn = null;
        if (is_array($data)) {
            //カテゴリ
            $cat = array(0);
            if (isset($data['catlist_cat_code'])) {
                $cat = explode(':', $data['catlist_cat_code']);
            }
            $cat = implode(',', $cat);

            //ラベル
            if (isset($data['catlist_label_code'])) {
                $_label = explode(':', $data['catlist_label_code']);
            }
            $label_flg = false;//ラベル設定されているかの判定用
            $label = array();
            if (!empty($_label[0])) {
                //ラベルをフィルター。アクティブ以外は破棄
                $label_flg = true;
                $result = $this->db->query('SELECT label_code FROM tbl_label WHERE label_code IN('.implode(',', $_label).') AND label_active=1');
                if ($result) {
                    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
                        $label[] = $row['label_code'];
                    }
                }
            }

            //セクションコード
            $pidx_sidx_code = (isset($data['catlist_sidx_code'])) ? $data['catlist_sidx_code'] : 0;
            //表示順
            $catlist_order = (isset($data['catlist_order']) && $data['catlist_order'] == 2) ? 'DESC' : '';
            //表示開始件数
            $catlist_s_count = (isset($data['catlist_s_count'])) ? $data['catlist_s_count'] : 0;
            //表示件数
            $catlist_limit = (isset($data['catlist_limit'])) ? $data['catlist_limit'] : 10;
            //NEW表示日数
            $catlist_new_days = (isset($data['catlist_new_days'])) ? $data['catlist_new_days'] : 7;
            //タイムスタンプ値に変更
            $catlist_new_days = $catlist_new_days * 86400;
            $offset = ($idx - 1) * $catlist_limit + ($catlist_s_count - 1);
            //該当するカテゴリからページ情報を取得
            $nowdate = date('Y-m-d H:i:s');

            //@FIXME 2011.04.28 公開時、プレビュー時を同じ表示とする ami
            //$_tmp = ($this->_prev) ? '_tmp' : '';
            $sql = 'SELECT
                p1.pidx_code,
                pidx_title,
                pidx_label,
                s1.sidx_code as cat_code,
                s2.sidx_code as sidx_code,
                s1.sidx_dir as cat_dir,
                s2.sidx_dir as sidx_dir,
                s1.sidx_title as cat_name,
                CASE
                WHEN s2.sidx_order IS NULL THEN s1.sidx_order
                ELSE s2.sidx_order END as menu_sidx_order,
                CASE
                WHEN s2.sidx_code IS NULL THEN s1.sidx_code
                ELSE s2.sidx_code END as menu_sidx_code,
                CASE
                WHEN s1.sidx_ssl=1 OR s2.sidx_ssl=1 THEN 1
                ELSE NULL END as sidx_ssl,
                pidx_date,
                pidx_comment,
                pidx_url,
                pidx_comment_pic,
                pidx_comment_pic2,
                skin_path,
                pidx_directurl,
                pidx_directurl_flg,
                pidx_nolink

                FROM tbl_page_idx as p1

                JOIN tbl_section_idx as s1
                ON s1.sidx_code=p1.pidx_sidx_code

                LEFT JOIN tbl_section_idx as s2
                ON s1.sidx_parent_sidx_code=s2.sidx_code

                JOIN tbl_template
                ON s1.sidx_tpl_code = tpl_code

                JOIN tbl_skin
                ON tpl_skin_code = skin_code

                WHERE pidx_ptype=1
                AND pidx_active=1
                AND pidx_view IN(0,2)
                AND s1.sidx_active=1
                AND s1.sidx_view=2 AND (s2.sidx_view=2 OR s2.sidx_view IS NULL)
                AND (s1.sidx_extmodule_code IS NULL OR NOT(s1.sidx_extmodule_code >=1000 AND s1.sidx_extmodule_code < 2000)) ';

            if ($cat != 0) {
                $sql .= " AND s1.sidx_code IN({$cat})";
            }
            if ($label_flg) {
                if (!empty($label)) {
                    $sql .= ' AND (';
                    foreach ($label as $k => $code) {
                        if ($k > 0) {
                            $sql .= ' OR ';
                        }
                        $sql .= " pidx_label={$code}
                            OR pidx_label LIKE '{$code}<>%'
                            OR pidx_label LIKE '%<>{$code}<>%'
                            OR pidx_label LIKE '%<>{$code}'";
                    }
                    $sql .= ')';
                } else {
                    $sql .= ' AND 1=0';
                }
            }
            $sql .= "  AND pidx_date <= '{$nowdate}' AND
                (pidx_edate Is Null OR pidx_edate >= '{$nowdate}') ";
            //2011.03.17 sugi
            //@todo v1.7で並び順変更
            $sql .= "ORDER BY p1.pidx_order desc, p1.pidx_date {$catlist_order}, p1.pidx_sameday_priority ASC, menu_sidx_order ASC, menu_sidx_code ASC, s2.sidx_order ASC, s2.sidx_code ASC, s1.sidx_order ASC, s1.sidx_code ASC, pidx_code DESC ";
            //$sql .= "ORDER BY p1.pidx_order desc, p1.pidx_date {$catlist_order}, p1.pidx_u_date {$catlist_order}, menu_sidx_order ASC, menu_sidx_code ASC, s2.sidx_order ASC, s2.sidx_code ASC, s1.sidx_order ASC, s1.sidx_code ASC, pidx_code DESC ";
            //スマホレイアウト表示時＋ページング時は全件取得
            if ($data['use_sp_flg'] == 1 && $data['catlist_sp_layout'] && $data['catlist_pflg'] == 1 && defined('SP_FLG') && SP_FLG == SP_FLG_CODE) {
                $offset = $catlist_s_count - 1;
                $sql .= "LIMIT 9999 Offset {$offset}";
            } else {
                $sql .= "LIMIT {$catlist_limit} Offset {$offset}";
            }

            $return = $this->db->query($sql);
            if (DB::IsError($return)) {
                die();
            }
            //現在のタイムスタンプ
            $now = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
            //カテゴリ名
            $cat_name = array();
            //開始ページ判定用変数
            $i = 1;
            while ($row = $return->fetchRow(DB_FETCHMODE_ASSOC)) {
                if (is_null($row['sidx_code'])) {
                    $row['sidx_code'] = $row['cat_code'];
                    $row['cat_code'] = null;
                    $row['sidx_dir'] = $row['cat_dir'];
                    $row['cat_dir'] = null;
                }
                //画像ファイルパス
                $row['PIDX_IMG_PATH'] = PIDX_IMG_PATH;
                //NEW_FLG
                $row['newflg'] = (strtotime($row['pidx_date']) + $catlist_new_days >= $now) ? 1 : 0;
                //SKIN_PATH
                $row['skin_path'] = $row['skin_path'];
                //ページのリンク設定
                $row['url'] = pageView::getSiteURL($row['sidx_dir'], $row['cat_dir'], $row['pidx_url'], $row['sidx_ssl'], $prev = false, false, true);

                if (!in_array($row['cat_name'], $cat_name)) {
                    $cat_name[] = $row['cat_name'];
                }
                //ラベル表示用
                if ($data['catlist_label_view'] == 1) {
                    $row_labels = array();
                    if ($row['pidx_label'] != '') {
                        $lsql = 'SELECT * FROM tbl_label WHERE label_active=1 AND label_admin_type=0 AND label_code IN('.str_replace('<>', ',', $row['pidx_label']).')';
                        $order = ' order by label_order, label_code desc';
                        $result = $this->db->prepare($lsql.$order, array());
                        if (PEAR::isError($result)) {
                            die($result->getMessage);
                        }
                        while ($lrow = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
                            $bgcolor = $lrow['label_color'];

                            //文字色を計算
                            $hex = strtr($bgcolor, array('#' => ''));

                            $r = substr($hex, 0, 2);
                            $g = substr($hex, 2, 2);
                            $b = substr($hex, 4, 2);
                            $rgb = array(hexdec($r), hexdec($g), hexdec($b));

                            // $comp = array();
                            // $max = 0;
                            // $min = 255;
                            // foreach ($rgb as $v) {
                            //     $max = max($max, $v);
                            //     $min = min($min, $v);
                            // }
                            //明度で白にするか黒にするか判定
                            // $blightness = $max / 255; 
                            $blightness = array_sum($rgb) / count($rgb) / 255;
                            
                            if(0.5 <= $blightness) {
                                $lrow['label_fcolor'] = '#000';
                            } else {
                                $lrow['label_fcolor'] = '#FFF';
                            }
                            
                            // //反転色計算
                            // $comp[] = 255 - $rgb[0];
                            // $comp[] = 255 - $rgb[1];
                            // $comp[] = 255 - $rgb[2];
                            // 
                            // $r = str_pad(dechex($comp[0]), 2, '0', STR_PAD_LEFT);
                            // $g = str_pad(dechex($comp[1]), 2, '0', STR_PAD_LEFT);
                            // $b = str_pad(dechex($comp[2]), 2, '0', STR_PAD_LEFT);
                            // 
                            // $lrow['label_fcolor'] = '#'.$r.$g.$b;

                            $row_labels[] = $lrow;
                        }
                    }
                    $row['label'] = $row_labels;
                }
                $this->_page_data[] = $row;
                ++$i;
            }
            //ページャー設定
            if ($data['catlist_pflg'] == 1) {
                //条件が複雑なので今後のことも考えて件数の取得方法を変更 2011.03.17 sugi
                //$total = $this->getPageCount($data); //公開記事総数
                $total = $this->getPageCount($data, $sql); //公開記事総数

                /* v1.3 動的にもどす*/
                $params = array('mode' => 'sliding',
                'totalItems' => $total,
                'perPage' => $catlist_limit,
                'delta' => 2,
                'prevImg' => '&lt;&lt;&nbsp;&nbsp;',
                'nextImg' => '&nbsp;&gt;&gt; ',
                'urlVar' => 'idx',
                'currentPage' => $idx,
                'curPageSpanPre' => '<b>[',
                'curPageSpanPost' => ']</b>',
                'separator' => '&nbsp;',
                'clearIfVoid' => true,
                'spacesBeforeSeparator' => 1,
                'spacesAfterSeparator' => 1,
                'itemData' => null,
                'httpMethod' => 'GET',
                'firstPagePre' => '[',
                'firstPageText' => _gettext('B_P00519'),
                'firstPagePost' => ']',
                'lastPagePre' => '[',
                'lastPageText' => _gettext('B_P00502'),
                'lastPagePost' => ']',
                'append' => false,
                  'fileName' => 'index.php?d='.$this->getRequest('d').'&c='.$this->getRequest('c').'&p='.$this->getRequest('p').'&pageu_code='.$this->_pageu_code.'&idx=%d',
                );
                if ($this->_prev == 1) { //v1.3
                    $params['fileName'] = $params['fileName'].'&prev=1';
                }
                //アンカー追加
                //$params["fileName"] = $params["fileName"]."#unit-".$this->_pageu_code;
                $pager = Pager::factory($params);
                //ページナビ
                $links = $pager->getLinks();
                if (isset($links['all']) && $links['all'] != '') {
                    $rtn['Pages'] = $links['all'];
                }
            }
            $rtn['pagedata'] = $this->_page_data;
            $rtn['category'] = $cat_name;

            return $rtn;
        }
    }
    /**
     * ページ件数取得.
     *
     * @param int    $data データ配列
     * @param string $sql  SQL
     *
     * @return int 件数
     */
    public function getPageCount($data, $sql)
    {
        //2011.03.17 sugi
        if (is_array($data)) {
            //表示開始件数
            $catlist_s_count = (isset($data['catlist_s_count'])) ? $data['catlist_s_count'] : 0;
            $offset = $catlist_s_count - 1;
            $patterns = array();
            $patterns[0] = '/SELECT.+FROM/is';
            $patterns[1] = '/ORDER BY.+$/is';
            $replacements = array();
            $replacements[0] = 'SELECT count(pidx_code) FROM';
            $replacements[1] = '';
            $sql = preg_replace($patterns, $replacements, $sql);

            return $this->db->getOne($sql) - $offset;
        }

        return 0;
    }
}
